@echo off
cd /D "%~dp0"
setlocal EnableDelayedExpansion
set /A "missing=0"
set /A "found=0"
set /A "skipped=0"
for /L %%n in (1 1 500) do if "!__cd__:~%%n,1!" neq "" set /a "len=%%n+1"

SET "TWikiFile="
if "%~1"=="-w" (
	SET "TWikiFile=%~2"
)
if "%~3"=="-f" (
	SET "TWikiFile=%~4"
)

if "!TWikiFile!"=="" (
	FOR /F "eol=| delims=" %%I IN ('DIR "*.html" /A-D /B /O-D /TW 2^>nul') DO (
		SET "TWikiFile=%%I"
		GOTO FoundFile
	)
	GOTO NoHTML
) else (
	if NOT Exist "!TWikiFile!" GOTO NoHTML
)
:FoundFile

set "Folder="
if "%~1"=="-f" (
	SET "Folder=%~2"
)
if "%~3"=="-f" (
	SET "Folder=%~4"
)

if "!Folder!" NEQ "" (
  if NOT Exist "!Folder!" GOTO NOFOLDER
  cd "!Folder!"
)

echo Generating report for: %~dp0!TWikiFile!
if "!Folder!" NEQ "" (
	echo   for folder and subfolders of !Folder!
)

echo. >"%~dp0twMissingImageReport.txt"
echo. >"%~dp0twIncludedImageReport.txt"
echo [ >"%~dp0twImagejson.json"

set "first=true"

for /r . %%g in (*.jpg *.jpeg *.png *.gif *.svg) do (
	set "absPath=%%g"  
	set "relPath=!absPath:~%len%!"
	set "include=no"
	set newpath=!relPath:\=\\\!

	findstr /I /c:"!newPath!" "%~dp0!TWikiFile!" >nul
	set "include=maybe"
	if !errorlevel! NEQ 0 (
		set "include=yes"
		echo !relPath!
		echo !relpath! >>"%~dp0twMissingImageReport.txt"
		set "filetype="
		for %%C in ("!relPath!") do (set "filename=%%~nC")
		for %%A in ("!relPath!") do (set "extension=%%~xA")
		if "!extension!"==".jpeg" set "filetype=jpg"
		if "!extension!"==".jpg" set "filetype=jpg"
		if "!extension!"==".png" set "filetype=png"
		if "!extension!"==".gif" set "filetype=gif"
		if "!extension!"==".svg" set "filetype=svg+xml"
		set "endPath=!relPath:\=\\!"
		if "!first!"=="true" (
			echo {^"text^":^"^",^"title^":^"!filename!!extension!^",^"type^":^"image/!filetype!^",^"_canonical_uri^":^"!endPath!^",^"tags^":^"^"} >>"%~dp0twImagejson.json"
			set "first=false"
		) else (
			echo ,{^"text^":^"^",^"title^":^"!filename!!extension!^",^"type^":^"image/!filetype!^",^"_canonical_uri^":^"!endPath!^",^"tags^":^"^"} >>"%~dp0twImagejson.json"
		)
	) else (
		echo !relpath! >>"%~dp0twIncludedImageReport.txt"
	)
	if "!include!"=="yes" (
	  set /a "missing+=1"	  
	) 
	if "!include!"=="maybe" (
	  set /a "found+=1"	  
	)
	if "!include!"=="no" (
	  set /a "skipped+=1"	  
	)
)
echo ] >>"%~dp0twImagejson.json"
echo **
REM echo ** Skipped: !skipped!
echo ** Found: !found! (included in MKIncludedImageReport.txt)
echo ** Missing: !missing! (included in MKMissingImageReport.txt)
echo ** DONE.
GOTO Done
:NoHTML
echo **
echo ** Either HTML File not found or specified.
echo **
echo ** Usage:
echo ** MKfileImageReport.bat -w MyMemoryKeeper.html -f images\sources
echo **
:Done
cd /D "%~dp0"
pause